#!/bin/sh
# ----------------------------------------------------------------------------
#  Copyright 2001-2006 The Apache Software Foundation.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
# ----------------------------------------------------------------------------

#   Copyright (c) 2001-2002 The Apache Software Foundation.  All rights
#   reserved.

BASEDIR=`dirname $0`/..
BASEDIR=`(cd "$BASEDIR"; pwd)`



# OS specific support.  $var _must_ be set to either true or false.
cygwin=false;
darwin=false;
case "`uname`" in
  CYGWIN*) cygwin=true ;;
  Darwin*) darwin=true
           if [ -z "$JAVA_VERSION" ] ; then
             JAVA_VERSION="CurrentJDK"
           else
             echo "Using Java version: $JAVA_VERSION"
           fi
           if [ -z "$JAVA_HOME" ] ; then
             JAVA_HOME=/System/Library/Frameworks/JavaVM.framework/Versions/${JAVA_VERSION}/Home
           fi
           ;;
esac

if [ -z "$JAVA_HOME" ] ; then
  if [ -r /etc/gentoo-release ] ; then
    JAVA_HOME=`java-config --jre-home`
  fi
fi

# For Cygwin, ensure paths are in UNIX format before anything is touched
if $cygwin ; then
  [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
  [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
fi

# If a specific java binary isn't specified search for the standard 'java' binary
if [ -z "$JAVACMD" ] ; then
  if [ -n "$JAVA_HOME"  ] ; then
    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
      # IBM's JDK on AIX uses strange locations for the executables
      JAVACMD="$JAVA_HOME/jre/sh/java"
    else
      JAVACMD="$JAVA_HOME/bin/java"
    fi
  else
    JAVACMD=`which java`
  fi
fi

if [ ! -x "$JAVACMD" ] ; then
  echo "Error: JAVA_HOME is not defined correctly."
  echo "  We cannot execute $JAVACMD"
  exit 1
fi

if [ -z "$REPO" ]
then
  REPO="$BASEDIR"/repo
fi

CLASSPATH=$CLASSPATH_PREFIX:"$BASEDIR"/conf:"$REPO"/org/yaml/snakeyaml/1.17/snakeyaml-1.17.jar:"$REPO"/org/slf4j/slf4j-api/1.7.25/slf4j-api-1.7.25.jar:"$REPO"/org/slf4j/slf4j-log4j12/1.7.14/slf4j-log4j12-1.7.14.jar:"$REPO"/log4j/log4j/1.2.17/log4j-1.2.17.jar:"$REPO"/org/apache/helix/helix-core/0.9.9/helix-core-0.9.9.jar:"$REPO"/org/apache/zookeeper/zookeeper/3.4.13/zookeeper-3.4.13.jar:"$REPO"/jline/jline/0.9.94/jline-0.9.94.jar:"$REPO"/org/apache/yetus/audience-annotations/0.5.0/audience-annotations-0.5.0.jar:"$REPO"/io/netty/netty/3.10.6.Final/netty-3.10.6.Final.jar:"$REPO"/commons-io/commons-io/1.4/commons-io-1.4.jar:"$REPO"/com/101tec/zkclient/0.5/zkclient-0.5.jar:"$REPO"/org/apache/commons/commons-math/2.1/commons-math-2.1.jar:"$REPO"/commons-codec/commons-codec/1.6/commons-codec-1.6.jar:"$REPO"/com/google/guava/guava/15.0/guava-15.0.jar:"$REPO"/io/dropwizard/metrics/metrics-core/3.2.3/metrics-core-3.2.3.jar:"$REPO"/org/apache/commons/commons-lang3/3.8.1/commons-lang3-3.8.1.jar:"$REPO"/org/apache/httpcomponents/httpclient/4.5.8/httpclient-4.5.8.jar:"$REPO"/org/apache/httpcomponents/httpcore/4.4.11/httpcore-4.4.11.jar:"$REPO"/commons-logging/commons-logging/1.2/commons-logging-1.2.jar:"$REPO"/org/eclipse/jetty/jetty-server/9.1.0.RC0/jetty-server-9.1.0.RC0.jar:"$REPO"/javax/servlet/javax.servlet-api/3.1.0/javax.servlet-api-3.1.0.jar:"$REPO"/org/eclipse/jetty/jetty-http/9.1.0.RC0/jetty-http-9.1.0.RC0.jar:"$REPO"/org/eclipse/jetty/jetty-util/9.1.0.RC0/jetty-util-9.1.0.RC0.jar:"$REPO"/org/eclipse/jetty/jetty-io/9.1.0.RC0/jetty-io-9.1.0.RC0.jar:"$REPO"/org/glassfish/jersey/core/jersey-server/2.10/jersey-server-2.10.jar:"$REPO"/org/glassfish/jersey/core/jersey-common/2.10/jersey-common-2.10.jar:"$REPO"/org/glassfish/jersey/bundles/repackaged/jersey-guava/2.10/jersey-guava-2.10.jar:"$REPO"/org/glassfish/hk2/osgi-resource-locator/1.0.1/osgi-resource-locator-1.0.1.jar:"$REPO"/org/glassfish/jersey/core/jersey-client/2.10/jersey-client-2.10.jar:"$REPO"/javax/ws/rs/javax.ws.rs-api/2.0/javax.ws.rs-api-2.0.jar:"$REPO"/javax/annotation/javax.annotation-api/1.2/javax.annotation-api-1.2.jar:"$REPO"/org/glassfish/hk2/hk2-api/2.3.0-b05/hk2-api-2.3.0-b05.jar:"$REPO"/org/glassfish/hk2/hk2-utils/2.3.0-b05/hk2-utils-2.3.0-b05.jar:"$REPO"/org/glassfish/hk2/external/aopalliance-repackaged/2.3.0-b05/aopalliance-repackaged-2.3.0-b05.jar:"$REPO"/org/glassfish/hk2/external/javax.inject/2.3.0-b05/javax.inject-2.3.0-b05.jar:"$REPO"/org/glassfish/hk2/hk2-locator/2.3.0-b05/hk2-locator-2.3.0-b05.jar:"$REPO"/org/javassist/javassist/3.18.1-GA/javassist-3.18.1-GA.jar:"$REPO"/javax/validation/validation-api/1.1.0.Final/validation-api-1.1.0.Final.jar:"$REPO"/org/eclipse/jetty/jetty-servlet/9.1.0.RC0/jetty-servlet-9.1.0.RC0.jar:"$REPO"/org/eclipse/jetty/jetty-security/9.1.0.RC0/jetty-security-9.1.0.RC0.jar:"$REPO"/org/glassfish/jersey/containers/jersey-container-jetty-http/2.9/jersey-container-jetty-http-2.9.jar:"$REPO"/org/eclipse/jetty/jetty-continuation/9.1.1.v20140108/jetty-continuation-9.1.1.v20140108.jar:"$REPO"/org/glassfish/jersey/containers/jersey-container-servlet-core/2.9/jersey-container-servlet-core-2.9.jar:"$REPO"/org/glassfish/jersey/containers/jersey-container-grizzly2-servlet/2.9/jersey-container-grizzly2-servlet-2.9.jar:"$REPO"/org/glassfish/jersey/containers/jersey-container-servlet/2.9/jersey-container-servlet-2.9.jar:"$REPO"/org/glassfish/jersey/containers/jersey-container-grizzly2-http/2.9/jersey-container-grizzly2-http-2.9.jar:"$REPO"/org/glassfish/grizzly/grizzly-http-server/2.3.8/grizzly-http-server-2.3.8.jar:"$REPO"/org/glassfish/grizzly/grizzly-http/2.3.8/grizzly-http-2.3.8.jar:"$REPO"/org/glassfish/grizzly/grizzly-framework/2.3.8/grizzly-framework-2.3.8.jar:"$REPO"/org/glassfish/grizzly/grizzly-http-servlet/2.3.8/grizzly-http-servlet-2.3.8.jar:"$REPO"/org/glassfish/jersey/test-framework/jersey-test-framework-core/2.15/jersey-test-framework-core-2.15.jar:"$REPO"/org/ow2/asm/asm-debug-all/5.0.2/asm-debug-all-5.0.2.jar:"$REPO"/org/glassfish/jersey/test-framework/providers/jersey-test-framework-provider-grizzly2/2.11/jersey-test-framework-provider-grizzly2-2.11.jar:"$REPO"/com/thoughtworks/xstream/xstream/1.3.1/xstream-1.3.1.jar:"$REPO"/xpp3/xpp3_min/1.1.4c/xpp3_min-1.1.4c.jar:"$REPO"/org/codehaus/jackson/jackson-core-asl/1.8.5/jackson-core-asl-1.8.5.jar:"$REPO"/org/codehaus/jackson/jackson-mapper-asl/1.8.5/jackson-mapper-asl-1.8.5.jar:"$REPO"/com/fasterxml/jackson/core/jackson-annotations/2.9.5/jackson-annotations-2.9.5.jar:"$REPO"/com/fasterxml/jackson/core/jackson-databind/2.9.5/jackson-databind-2.9.5.jar:"$REPO"/com/fasterxml/jackson/core/jackson-core/2.9.5/jackson-core-2.9.5.jar:"$REPO"/commons-cli/commons-cli/1.2/commons-cli-1.2.jar:"$REPO"/org/apache/helix/helix-rest/0.9.9/helix-rest-0.9.9.jar
EXTRA_JVM_ARGUMENTS="-Xms512m -Xmx512m"

# For Cygwin, switch paths to Windows format before running java
if $cygwin; then
  [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
  [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
  [ -n "$HOME" ] && HOME=`cygpath --path --windows "$HOME"`
  [ -n "$BASEDIR" ] && BASEDIR=`cygpath --path --windows "$BASEDIR"`
  [ -n "$REPO" ] && REPO=`cygpath --path --windows "$REPO"`
fi

exec "$JAVACMD" $JAVA_OPTS \
  $EXTRA_JVM_ARGUMENTS \
  -classpath "$CLASSPATH" \
  -Dapp.name="run-rest-admin" \
  -Dapp.pid="$$" \
  -Dapp.repo="$REPO" \
  -Dbasedir="$BASEDIR" \
  org.apache.helix.rest.server.HelixRestMain \
  "$@"
